#ifndef FALAK_H_INCLUDED
#define FALAK_H_INCLUDED

#include <SDL.h>
#include "pontok.h"
#include "toltesek.h"

/** Strukturak */
    /** Fal struktura, ket vegpont hatarozza meg */
    typedef struct {
        Pont a, b;
        short dir;
        short touched;
    } Fal;

    /** A falak lancolt listaban vannak tarolva, *
      * ez a struktura a lista egy eleme         */
    typedef struct fallista {
        Fal fal;
        struct fallista *kov;
    } FalLista;

/** Valtozok */
    /** A lancolt listahoz szukseges pointerek */
    extern FalLista *uj_fal;
    extern FalLista *mozgoptr_fal;
    extern FalLista *elso_fal;
    extern FalLista *utolso_fal;

/** Fuggvenyek */
    Fal Fal_legyen (int dir, int fix, int h1, int h2);
    void Fal_letrehoz (int dir, int fix, int h1, int h2);
    void Fal_kiir (Fal f);
    void FalLista_kiir (void);
    void Fal_rajzol (SDL_Surface *screen, Fal f);
    int fuggoleges_falhoz_er (Mozgotoltes p);
    int vizszintes_falhoz_er (Mozgotoltes p);
    int falban_lenne (int x, int y, int toltesr);

#endif // FALAK_H_INCLUDED
