#include <SDL_gfxPrimitives.h>
#include "menu.h"
#include "szinek.h"

extern int menuwidth;
extern int HEIGHT;
extern colorscheme accent;

/** Ellenorzi, hogy egy adott x,y koordinatara kattintas *
  * az adott id-vel  rendelkezo gombra kattintott -e     */
int Button_click (int buttonid, int xpos, int ypos, Button *menu) {
    int leftedge = 10;
    int rightedge = menuwidth - 10 - 5;
    int button_top = buttonid * 10 + (buttonid-1) * 30;
    int button_bottom = buttonid * 10 + buttonid * 30;
    return ((leftedge < xpos) && (xpos < rightedge) && (button_top < ypos) && (ypos < button_bottom) && menu[buttonid].enabled);
}

/** Kirajzol egy adott id-vel rendelkezo gombot a kerpernyora */
void Button_draw (SDL_Surface *screen, int buttonid, Button button) {
    int leftedge = 10;
    int rightedge = menuwidth - 10 - 5;
    int button_top = buttonid * 10 + (buttonid - 1) * 30;
    int button_bottom = buttonid * 10 + buttonid * 30;
    int button_colour_r = !button.enabled ? accent.btdisabled.r : button.clicked ? accent.btclicked.r : (button.enabled == -1) ? accent.btnew.r : accent.btenabled.r;
    int button_colour_g = !button.enabled ? accent.btdisabled.g : button.clicked ? accent.btclicked.g : (button.enabled == -1) ? accent.btnew.g : accent.btenabled.g;
    int button_colour_b = !button.enabled ? accent.btdisabled.b : button.clicked ? accent.btclicked.b : (button.enabled == -1) ? accent.btnew.b : accent.btenabled.b;
    int text_colour_r = !button.enabled ? accent.textdisabled.r : button.clicked ? accent.textclicked.r : (button.enabled == -1) ? accent.textnew.r : accent.textenabled.r;
    int text_colour_g = !button.enabled ? accent.textdisabled.g : button.clicked ? accent.textclicked.g : (button.enabled == -1) ? accent.textnew.g : accent.textenabled.g;
    int text_colour_b = !button.enabled ? accent.textdisabled.b : button.clicked ? accent.textclicked.b : (button.enabled == -1) ? accent.textnew.b : accent.textenabled.b;

    boxRGBA(screen, leftedge, button_top, rightedge, button_bottom, button_colour_r, button_colour_g, button_colour_b, 255);
    stringRGBA(screen, leftedge + 10, button_top + 12, button.label, text_colour_r, text_colour_g, text_colour_b, 255);
}

/** Kirajzolja a menut */
void drawmenu (SDL_Surface *screen, Button *menu) {
    boxRGBA(screen, 0, 0, menuwidth-5, HEIGHT, accent.menubgcolor.r, accent.menubgcolor.g, accent.menubgcolor.b, 255); /** Menu hatter */
    boxRGBA(screen, menuwidth-4, 0, menuwidth, HEIGHT, accent.menudivcolor.r, accent.menudivcolor.g, accent.menudivcolor.b, 255); /** Menu elvalaszto */
    int i;
    for (i = 1; menu[i].clicked != -1; i++) /** Gombok */
        Button_draw (screen, i, menu[i]);
}
