#ifndef TOLTESEK_H_INCLUDED
#define TOLTESEK_H_INCLUDED

#include <SDL.h>
#include "pontok.h"
#include "vektorok.h"

/** Strukturak */
    /** Toltesek struktura */
    /** Tartalmazza a toltes koordinatait, toltesenek     *
      * erteket, illetve azt, hogy a toltes modosithato-e */
    typedef struct {
        int x;
        int y;
        int charge;
        int editable;
    } Toltes;

    /** Mozgo toltes struktura */
    /** A toltesek jellemzoi mellett rendelkezik      *
      * egy sebessegvektorral is, ez a proton tipusa. */
    typedef struct {
        double x;
        double y;
        int r;
        int charge;
        Vektor v;
    } Mozgotoltes;

    /** A toltesek lancolt listaban vannak tarolva, *
      * ez a struktura a lista egy eleme            */
     typedef struct tolteslista {
        Toltes toltes;
        struct tolteslista *kov;
        struct tolteslista *elozo;
    } ToltesLista;

/** Valtozok */
    extern ToltesLista *uj;
    extern ToltesLista *mozgoptr;
    extern ToltesLista *elso;
    extern ToltesLista *utolso;
    extern ToltesLista *elsonemfix;
    extern ToltesLista *utolsofix;

/** Fuggvenyek */
    void Toltes_kiir (Toltes q);
    void ToltesLista_kiir (void);
    Vektor Coulomb_ero (Mozgotoltes proton, Toltes q);
    Toltes Toltes_legyen (int x, int y, int charge, int editable);
    void Toltes_letrehoz (int x, int y, int charge);
    void fixToltes_letrehoz (int x, int y, int charge);
    void Toltes_torol (ToltesLista *prev, ToltesLista *next);
    void Toltes_novel (Pont racspont);
    void Toltes_csokkent (Pont racspont);
    void Toltes_rajzol (SDL_Surface *screen, Toltes q, int toltesr, Mozgotoltes proton, int shownumbers);
    void Mozgotoltes_rajzol (SDL_Surface *screen, Mozgotoltes p);

#endif // TOLTESEK_H_INCLUDED
